std::swap(std::multiset)(3)

NAME
std::swap(std::multiset) - std::swap(std::multiset)

Synopsis
   Defined in header <set>
   template< class Key, class Compare, class Alloc >
   void swap( std::multiset<Key,Compare,Alloc>& lhs, (until C++17)
   std::multiset<Key,Compare,Alloc>& rhs );
   template< class Key, class Compare, class Alloc >
   void swap( std::multiset<Key,Compare,Alloc>& lhs, (since C++17)
   std::multiset<Key,Compare,Alloc>& rhs ) noexcept(/* see below */);
   Specializes the std::swap algorithm for std::multiset. Swaps the contents of lhs and
   rhs. Calls lhs.swap(rhs).

Parameters
   lhs, rhs - containers whose contents to swap

Return value
   (none)

Complexity
   Constant.

Exceptions
   noexcept specification: (since C++17)
   noexcept(noexcept(lhs.swap(rhs)))

Notes
   Although the overloads of std::swap for container adaptors are introduced in C++11,
   container adaptors can already be swapped by std::swap in C++98. Such calls to
   std::swap usually have linear time complexity, but better complexity may be
   provided.

Example
// Run this code
 #include <algorithm>
 #include <iostream>
 #include <set>
 int main()
 {
     std::multiset<int> alice{1, 2, 3};
     std::multiset<int> bob{7, 8, 9, 10};
     auto print = [](const int& n) { std::cout << ' ' << n; };
     // Print state before swap
     std::cout << "alice:";
     std::for_each(alice.begin(), alice.end(), print);
     std::cout << "\n" "bob :";
     std::for_each(bob.begin(), bob.end(), print);
     std::cout << '\n';
     std::cout << "-- SWAP\n";
     std::swap(alice, bob);
     // Print state after swap
     std::cout << "alice:";
     std::for_each(alice.begin(), alice.end(), print);
     std::cout << "\n" "bob :";
     std::for_each(bob.begin(), bob.end(), print);
     std::cout << '\n';
 }

Output:
 alice: 1 2 3
 bob : 7 8 9 10
 -- SWAP
 alice: 7 8 9 10
 bob : 1 2 3

See also
   swap swaps the contents
        (public member function)